<?php
namespace App\Models\Configuracion;

class FormaPagoModel extends \App\Models\BaseModel
{
    protected $table = "formas_pago";

    /**
     * Whether primary key uses auto increment.
     *
     * @var bool
     */
    protected $useAutoIncrement = true;

    const SORTABLE = [
        1 => "t1.id",
        2 => "t1.nombre",
    ];

    protected $allowedFields = ["nombre"];
    protected $returnType = "App\Entities\Configuracion\FormaPagoEntity";

    public static $labelField = "nombre";

    protected $validationRules = [
        "nombre" => [
            "label" => "FormasPago.nombre",
            "rules" => "trim|required|max_length[255]",
        ],
    ];

    protected $validationMessages = [
        "nombre" => [
            "max_length" => "FormasPago.validation.nombre.max_length",
            "required" => "FormasPago.validation.nombre.required",
        ],
    ];

    public function getMenuItems(){
        $items = $this->findAll();
        $menuItems = [];
        foreach ($items as $item) {
            $menuItems[] = [
                "value" => $item->id,
                "label" => $item->nombre,
            ];
        }
        return $menuItems;
    }

    /**
     * Get resource data.
     *
     * @param string $search
     *
     * @return \CodeIgniter\Database\BaseBuilder
     */
    public function getResource(string $search = "")
    {
        $builder = $this->db
            ->table($this->table . " t1")
            ->select("t1.id AS id, t1.nombre AS nombre");

        return empty($search)
            ? $builder
            : $builder
                ->groupStart()
                ->like("t1.id", $search)
                ->orLike("t1.nombre", $search)
                ->groupEnd();
    }
}
